import { EventEmitter } from '../class/emitter.js';
import { NostrSocket } from '../class/socket.js';
import { EventFilter, SignedEvent, SubscribeConfig } from '../types.js';
export declare class NostrSub extends EventEmitter<{
    'cancel': NostrSub;
    'event': SignedEvent;
    'ready': NostrSub;
}> {
    readonly _opt: SubscribeConfig;
    readonly _socket: NostrSocket;
    readonly _sub_id: string;
    _filter: EventFilter;
    _init: boolean;
    constructor(socket: NostrSocket, filter?: EventFilter, options?: Partial<SubscribeConfig>);
    get filter(): EventFilter;
    get sub_id(): string;
    get ready(): boolean;
    cancel(): void;
    update(filter?: EventFilter): Promise<NostrSub>;
    when_cancel(): Promise<unknown>;
    when_ready(): Promise<unknown>;
}
